	program block_var
c
c	finds correlation interval in MC data by the block variance method
c
	parameter(nm=1000000,nbvalues=18)
	dimension e(nm),ebar(nm)
	dimension ibvalues(nbvalues)
	character*24 filename
	data ibvalues/1,2,5,10,20,50,100,200,500,1000,2000,5000,10000,
     &	20000,50000,100000,200000,500000/

	write(6,*) 'enter input data file'
	read(5,'(a24)') filename
	open(unit=1,file=filename,form='formatted',status='old')

	np=0
	e1=0.
	v1=0.
	do
		read(1,*,err=100,end=100) xx
		np=np+1
		e(np)=xx
		e1=e1+xx
		v1=v1+xx**2
	enddo
100	e1=e1/float(np)
	v1=v1/float(np)-e1*e1
	write(6,*) 
	write(6,*) np,' data points read'
	write(6,*) 'global mean & variance:',e1,v1
	write(6,*) 
	write(6,*) 'b     ratio'
	write(6,*) '-     -----'

   	do i=1,nbvalues

	ib=ibvalues(i)
	nb=np/ib
	xib=1./float(ib)
	if(nb.lt.1) exit

	ebar=0.
	vb=0.
	do j=1,nb
		do k=1+(j-1)*ib,j*ib
			ebar(j)=ebar(j)+e(k)
		enddo
		ebar(j)=ebar(j)*xib
		vb=vb+ebar(j)**2
	enddo 
	vb=vb/float(nb)-e1*e1
	write(6,*) ib,ib*vb/v1

	enddo

	stop
	end
