      subroutine mcmove(en, vir, attempt, nacc, dr)
c
c     attempts to displace a randomly selected molecule
c
c
c     ener   (input/output) : total energy
c     vir    (input/output) : total virial
c     attemp (input/output) : number of attemps that have been
c                             performed to displace a particle
c     nacc   (input/output) : number of successful attemps
c                             to displace a particle
c     dr     (input)        : maximum displacement
c
      implicit none
      include 'params.inc'
      real enn, eno, en, ran_uniform, 
     &     viro, virn, vir, dr, drr, drt
      real xn1, yn1, zn1, xn2, yn2, zn2, wx, wy, wz, w2,
     &     uxo, uyo, uzo, uxn, uyn, uzn, u2, dx, dy, dz,
     &     eno1, eno2, viro1, viro2, enn1, enn2, virn1, virn2
      integer o, attempt, nacc, jb, rt, o1, o2
 
      attempt = attempt + 1
      jb = 1

c     ---select a molecule o at random and identify its atoms o1 & o2

      o = int(real(npart/2)*ran_uniform()) + 1
      o1 = 2*o -1
      o2 = 2*o 

c     ---calculate energy old configuration

      call eneri(x(o1), y(o1), z(o1), o1, jb, eno1, viro1)
      call eneri(x(o2), y(o2), z(o2), o2, jb, eno2, viro2)
      eno = eno1 + eno2
      viro = viro1 + viro2

c     --- choose translation or rotation move

      rt = ran_uniform()

      if(rt.lt.0.5) then

      	dx = (ran_uniform()-0.5)*drt
      	dy = (ran_uniform()-0.5)*drt
      	dz = (ran_uniform()-0.5)*drt
	
	xn1 = x(o1) + dx
	yn1 = y(o1) + dy
	zn1 = z(o1) + dz
	
	xn2 = x(o2) + dx
	yn2 = y(o2) + dy
	zn2 = z(o2) + dz

      else

        uxo = x(o1)-x(o2)
        uyo = y(o1)-y(o2)
        uzo = z(o1)-z(o2)
	u2 = uxo*uxo + uyo*uyo + uzo*uzo
        u2 = 1./sqrt(u2)
 	uxo = uxo*u2
 	uyo = uyo*u2
 	uzo = uzo*u2

	w2 = 2.
	do while (w2.gt.1.)
	    wx = 2. * ran_uniform() -1.
	    wy = 2. * ran_uniform() -1.
	    wz = 2. * ran_uniform() -1.
	    w2 = wx*wx + wy*wy + wz*wz
	enddo
	w2 = 1./sqrt(w2)
        wx = wx *w2
        wy = wy *w2
        wz = wz *w2

        uxn = uxo + (ran_uniform()-0.5)*drr
        uyn = uyo + (ran_uniform()-0.5)*drr
        uzn = uzo + (ran_uniform()-0.5)*drr
	u2 = uxn*uxn + uyn*uyn + uzn*uzn
        u2 = 1./sqrt(u2)
 	uxn = uxn*u2
 	uyn = uyn*u2
 	uzn = uzn*u2

        xn1 = 0.5*(x(o1) + x(o2) + uxn)
        yn1 = 0.5*(y(o1) + y(o2) + uyn)
        zn1 = 0.5*(z(o1) + z(o2) + uzn)

        xn2 = 0.5*(x(o1) + x(o2) - uxn)
        yn2 = 0.5*(y(o1) + y(o2) - uyn)
        zn2 = 0.5*(z(o1) + z(o2) - uzn)

      endif

c     ---calculate energy new configuration:

      call eneri(xn1, yn1, zn1, o1, jb, enn1, virn1)
      call eneri(xn2, yn2, zn2, o2, jb, enn2, virn2)
      enn = enn1 + enn2
      virn = virn1 + virn2

c     ---acceptance test

      if (ran_uniform().lt.exp(-beta*(enn-eno))) then

c        --accepted

         nacc = nacc + 1
         en = en + (enn-eno)
         vir = vir + (virn-viro)

c        ---put particle in simulation box

         if (xn1.lt.0.0) then
            xn1 = xn1 + box
         elseif (xn1.gt.box) then
            xn1 = xn1 - box
         endif

         if (yn1.lt.0.0) then
            yn1 = yn1 + box
         elseif (yn1.gt.box) then
            yn1 = yn1 - box
         endif

         if (zn1.lt.0.0) then
            zn1 = zn1 + box
         elseif (zn1.gt.box) then
            zn1 = zn1 - box
         endif

         if (xn2.lt.0.0) then
            xn2 = xn2 + box
         elseif (xn2.gt.box) then
            xn2 = xn2 - box
         endif

         if (yn2.lt.0.0) then
            yn2 = yn2 + box
         elseif (yn2.gt.box) then
            yn2 = yn2 - box
         endif

         if (zn2.lt.0.0) then
            zn2 = zn2 + box
         elseif (zn2.gt.box) then
            zn2 = zn2 - box
         endif

         x(o1) = xn1
         y(o1) = yn1
         z(o1) = zn1

         x(o2) = xn2
         y(o2) = yn2
         z(o2) = zn2
      end if
      return
      end

